---
- name: Switch to pgdg if we are a supported 64-bit arch
  ansible.builtin.include_tasks:
    file: psql_pgdg.yml
  when: ansible_facts['architecture'] in ['amd64', 'arm64', 'ppc64el' 's390x']

- name: Install PostgreSQL
  ansible.builtin.apt:
    state: present
    update_cache: yes
    pkg:
      - postgresql-16

- name: Start PostgreSQL service
  ansible.builtin.service:
    name: postgresql
    state: started
    enabled: yes

- name: Create ansible tmp directory for postgresql user
  ansible.builtin.file:
    path: /var/lib/postgresql/.ansible/tmp
    mode: "0700"
    state: directory
    owner: postgres
    group: postgres

- name: Install python3 postgresql connection library
  ansible.builtin.apt:
    state: present
    pkg:
      - python3-psycopg

- name: Enable listening everywhere
  community.postgresql.postgresql_set:
    name: listen_addresses
    value: "*"
  become: yes
  become_user: postgres
  notify: Restart PostgreSQL

- name: pg_hba
  ansible.builtin.copy:
    src: templates/pg_hba.conf
    dest: /etc/postgresql/16/main/pg_hba.conf
    remote_src: false
    mode: "0640"
    backup: yes
  notify: Restart PostgreSQL

- name: postgres db-user gets a password
  community.postgresql.postgresql_user:
    user: postgres
    password: "{{ postgres_passwd_postgres[inventory_hostname] | default(postgres_passwd_postgres['default']) }}"
  become: yes
  become_user: postgres

- name: Flush handlers
  meta: flush_handlers
